#include <JTC/JTC.h>
#include <iostream.h>
#define M 10

/*
 * Legenda. 
           chifuma[i] = 1 -> Il fumatore i sta fumando e il posacenere  davanti a lui
		   chifuma[i] = 2 -> Il fumatore i sta fumando usando il posacenere posto alla sua sinistra
		   chifuma[i] = 3 -> Il fumatore i sta fumando usando il posacenere posto alla sua destra
		   alcentro = true -> il posacenere  disponibile al centro del tavolo
 */

class tavolo : public JTCMonitor
{

	int chifuma[M];
	bool alcentro;
public:
	tavolo()
	{
		for(int i=0;i<M;i++)
			chifuma[i]=0;
		alcentro=true;
	}
	void prendiposacenere(int i)
	{
		JTCSynchronized sync(*this);
		while(!alcentro && chifuma[(i+1)%M]!=1 && chifuma[(i-1)%M]!=1)
			wait();

		if(alcentro){
			alcentro=false;
		    chifuma[i]=1;
		}
		else
		{
			if (chifuma[(i+1)%M]==1)
			    chifuma[i]=3;
			else
				chifuma[i]=2;
		}
	}
	void lasciaposacenere(int i)
	{
		JTCSynchronized sync(*this);
		switch(chifuma[i])
		{
		case 1:
			while(chifuma[(i+1)%M]==2 && chifuma[(i-1)%M]==3)
				wait();
						
			if(chifuma[(i+1)%M]==0 && chifuma[(i-1)%M]==0)
			{
				alcentro=true;
				chifuma[i]=0;
				notifyAll();
			}
			else
			{
				if (chifuma[(i+1)%M]==2 && chifuma[(i-1)%M]==0)
				{
					chifuma[(i+1)%M]=1;
				    chifuma[i]=0;
					notifyAll();
				}
				else
					if(chifuma[(i+1)%M]==0 && chifuma[(i-1)%M]==3)
					{
						chifuma[(i-1)%M]=1;
					    chifuma[i]=0;
						notifyAll();
					}


			}
			break;
		case 2:
			chifuma[i]=0;
			notifyAll();
			break;
		case 3:
            chifuma[i]=0;
			notifyAll();
			break;
		}
	}

};
	
		
tavolo tab;
class fumatori :public JTCThread
{

	int id;

public:
	fumatori(int c){id=c;}
	void stofumando()
	{
		cout<<"sta fumando il num"<<id<<endl;
		sleep(rand()%50000);
	}
	virtual void run()
	{
		while(true)
		{
			cout<<"sono il fumatore n"<<id<<"voglio fumare"<<endl;
			tab.prendiposacenere(id);
			stofumando();
			cout<<"sono il num"<<id<<"voglio lasciare il tavolo"<<endl;
			tab.lasciaposacenere(id);
			cout<<"sonoil num"<<id<<"ho finito di fumare"<<endl;
		}
    }

};
		
		
		
int main()
{
	JTCInitialize initialize;
	fumatori* f[10];
	for (int i=0;i<M;i++){
		f[i]= new fumatori(i);
	f[i]->start();
	}
return 0;
}
		
		
		
		
		


