

#include <JTC\JTC.h>
#include <iostream.h>

#define LEN 40
 
class Buffer : public JTCMonitor

{
	char thebuffer[LEN];
	int in;
	int out;
	int chars;

public:
	Buffer()
	{
		in = 0;
		out = 0;
		chars = 0;
	}

    void printBuffer() 
	{
		JTCSynchronized sync(*this);
		cout << "|";
		for (int i = 0; i < LEN; i++)
		{
			if (in < out) 
			{
				if (i <= in)
					cout << thebuffer[i];
				else if (i <= out)
					cout << "*"; 
				else 
					cout << thebuffer[i];
			}
            else 
			{
				if (i <= out)
					cout << "*";
				else if (i <= in)
					cout << thebuffer[i];
				else 
					cout << "*";
			}
		}
		cout << "|\n";
	}

	char get()
	{
		JTCSynchronized sync(*this);
		while (chars == 0) {
			wait();
		}
		chars--; 
		char c = thebuffer[out];
		out = ( out + 1 ) % LEN;
		cout << "Chars=" << chars << " Out=" << out << endl;
		printBuffer();
		if (chars == LEN-1) // chars was previously 255
			notify();
		return c;
	}
 
	void put(char c)
	{
		JTCSynchronized sync(*this);
		while (chars == LEN) {
			wait();
		}
		chars++;
        thebuffer[in] = c;
		in = (in + 1) % LEN;
	    cout << "Chars=" << chars << " In=" << in << endl;
		printBuffer();
		if (chars == 1)
			notify();
	}
};

 Buffer b;

class Producer : public JTCThread

{
	int id;
	char c;
public:
	Producer(int i)
	{
		id = i;
		c = 'a';
	}
	virtual void run()
	{
		while(true) {
			sleep(rand() % 1000);
			cout << "Producer " << id << " awakes " << endl;
			b.put(c);
			cout << "Producer " << id << " puts " << c++ << endl; 
		}
	}
};

class Consumer : public JTCThread

{
	int id;
public:
	Consumer(int i)
	{
		id = i;
	}
	virtual void run()
	{
		while(true) {
			sleep(rand() % 5000);
			cout << "Consumer " << id << " awakes " << endl;
			cout << "Consumer " << id << " gets " << b.get() << endl; 
		}
	}
};

int main(int argc, char* argv[])

{   
	JTCInitialize initialize;
	Producer* p[2];
	Consumer* c[4];
    for (int i = 0; i < 2; i++) {
		p[i] = new Producer(i);
		p[i]->start();
	}
	for (i = 0; i < 4; i++) {
		c[i] = new Consumer(i);
		c[i]->start();
	}
	return 0;	
}