#include <JTC\JTC.h>
#include <iostream.h>
 
class SharedFile : public JTCMonitor

{
	int dato;
	int readerCount;
	bool writeMode;

public:
	SharedFile()
	{
		dato = 0;
		readerCount = 0;
		writeMode = false;
	}
	void startRead()
	{
		JTCSynchronized sync(*this);
		while(writeMode)
			wait();
		++readerCount;
	};
	void endRead()
	{
		JTCSynchronized sync(*this);
		--readerCount;
		if (readerCount == 0)
			notify();
	};
	void startWrite ()
	{
		JTCSynchronized sync(*this);
		while (readerCount > 0 || writeMode)
			wait();
		writeMode = true;
	};
	void endWrite()
	{
		JTCSynchronized sync(*this);
		writeMode = false;
		notifyAll();
	};
	int fread()
	{
		return dato;
	}
	void fwrite(int i)
	{
		dato = i;
	}
};

 SharedFile f;

class Writer : public JTCThread

{
	int id;
public:
	Writer(int i)
	{
		id = i;
	}
	virtual void run()
	{
		while(true) {
			cout << "Writer " << id << " Attempts to write " << endl;
			f.startWrite();		
			cout << "Writer " << id << " Starts to write " << endl;
			sleep(rand() % 1000);
			f.fwrite(id);
			f.endWrite();
			cout << "Writer " << id << " Ends writing " << endl;
			sleep(rand() % 5000);
		}
	}
};

class Reader : public JTCThread

{
	int id;
public:
	Reader(int i)
	{
		id = i;
	}
	virtual void run()
	{
		while(true) {
			cout << "Reader " << id << " Attempts to read " << endl;
			f.startRead();		
			cout << "Reader " << id << " Starts to read " << endl;
			sleep(rand() % 100);
			cout << "Reader " << id << " reads " << f.fread() << endl;
			f.endRead();
			cout << "Reader " << id << " Ends reading " << endl;
			sleep(rand() % 5000);
		}
	}
};

int main(int argc, char* argv[])

{   
	JTCInitialize initialize;
	Writer* p[2];
	Reader* c[4];
    for (int i = 0; i < 2; i++) {
		p[i] = new Writer(i);
		p[i]->start();
	}
	for (i = 0; i < 4; i++) {
		c[i] = new Reader(i);
		c[i]->start();
	}
	return 0;	
}