
#include <JTC\JTC.h>
#include <iostream.h>
#include <time.h>

class posto : public JTCMonitor
{
	bool occupato;
public:
	posto() { occupato = false; };
	bool prenota()
	{
		JTCSynchronized sync(*this);
		if (!occupato)
		{
			occupato = true;
			return true;
		}
		return false;
	}
};
#define MAX 2
posto posti[MAX];

class Thread : public JTCThread
{
	int id;
public:
	Thread(int i)
	{
		id = i;
	}
	int getId()
	{ return id; }
	virtual void run()
	{
       while(true)
	   {
		   cout << "Io sono il thread n." << id << endl;
		   sleep(rand() % 5000);
	   }
	}
};

class Concorrente : public Thread

{   public:
	Concorrente(int i) : Thread(i) {};
	virtual void run()
	{
		bool trovatoPosto = false;
		int postoDaTentare = 0;
		srand(getId() * 10000 + time(0));
		sleep(rand() % 5000);
		while (!trovatoPosto && postoDaTentare < MAX) {
			if (posti[postoDaTentare].prenota())
				trovatoPosto = true;
			else 
				postoDaTentare++;
		}
		cout << "Io sono il Thread n." << getId();  
	    if (trovatoPosto)
			cout << ". Ho rubato il posto n." 
			     << postoDaTentare << endl;
		else
			cout << ". Non ho trovato posto :(" << endl;
	}
};
// Ridefinire il metodo run per ciascuna delle tre classi
class ConcorrenteIntelligente : public Concorrente

{   public:
		ConcorrenteIntelligente(int i) : Concorrente(i) {};
	
};

class ConcorrenteFurbo : public Concorrente

{   public:
ConcorrenteFurbo(int i) : Concorrente(i) {};
	
};

class ConcorrenteEinstein : public Concorrente

{   public:
ConcorrenteEinstein(int i) : Concorrente(i) {};
	
};


void main ()
{
	JTCInitialize init;
	Concorrente* concorrenti[MAX+1];
	concorrenti[0] = new ConcorrenteFurbo(1);
	concorrenti[1] = new ConcorrenteIntelligente(2);
	concorrenti[2] = new ConcorrenteEinstein(3);
	// creare qui altri concorrenti per un totale di MAX+1
	// ...
	// 
	int numPartiti = 0;
	bool partiti[MAX+1];
	for (int i = 0; i < MAX+1; i++)
		partiti[i] = false;
	int toStart;
	// vengono fatti partire dei concorrenti in ordine casuale
	srand(time(0));
	while (numPartiti < MAX + 1) {
		toStart = rand() % (MAX + 1);
		if (!partiti[toStart]) {
				concorrenti[toStart]->start();
				partiti[toStart] = true;
				numPartiti++;
		}
	}
		   

}
