
//versione con starvation consentita

#define MAX 5

class Spogliatoio : public JTCMonitor

{
	bool docce[MAX];
	int numMaschi;
	int numFemmine;
    
	// ritorna l'indice di una doccia libera
	// non  necessario che il metodo sia sincronizzato poich verr chiamato da metodi che
	// hanno gi occupato il monitor di questa classe
	int trovaDoccia() 
	{
		for (int i = 0; i < MAX; i++)
			if (!docce[i])
				return i;
		return -1;
	}

public :
	Spogliatoio() { 
		for (int i = 0; i < MAX; i++)
			docce[i] = false;
		numMaschi = 0;
		numFemmine = 0;
	}

	
	//Alloca doccia per un maschietto; ritorna il numero di posto
	int occupaDocciaMaschio()
	{
		JTCSynchronized sync(*this);
		while( numMaschi == MAX || numFemmine > 0)
			wait();
		numMaschi++;
		return trovaDoccia(); // il monitor viene liberato dopo la return
	}
	int occupaDocciaFemmina()
	{
		JTCSynchronized sync(*this);
		while( numFemmine == MAX || numMaschi > 0)
			wait();
		numFemmine++;
		return trovaDoccia(); // il monitor viene liberato dopo la return
	}
	void liberaDocciaMaschio(int doccia)
	{
		numMaschi--;
		docce[doccia] = false;
		notifyAll();
	}
    void liberaDocciaFemmina(int doccia)
	{
		numFemmine--;
		docce[doccia] = false;
		notifyAll();
	}

};
