

#define MAX 5
#define SOGLIA 5 // non ci possono essere pi di SOGLIA persone dello stesso sesso in attesa

class Spogliatoio : public JTCMonitor

{
	bool docce[MAX];
	int numMaschi;
	int numFemmine;
	int maschiInAttesa;
	int femmineInAttesa;
	int stessoSessoConsecutivi;

	// ritorna l'indice di una doccia libera
	// non  necessario che il metodo sia sincronizzato poich verr chiamato da metodi che
	// hanno gi occupato il monitor di questa classe
	int trovaDoccia() 
	{
		for (int i = 0; i < MAX; i++)
			if (!docce[i])
				return i;
		return -1;
	}

public :
	Spogliatoio() { 
		for (int i = 0; i < MAX; i++)
			docce[i] = false;
		numMaschi = 0;
		numFemmine = 0;
		maschiInAttesa;
		femmineInAttesa;
		stessoSessoConsecutivi = 0;
	}

	
	//Alloca doccia per un maschietto; ritorna il numero di posto
	int occupaDocciaMaschio()
	{
		JTCSynchronized sync(*this);
		maschiInAttesa++;
		// non mi permetto di entrare se
		// a. lo spogliatoio  pieno
		// b. nello spogliatoio c' qualcuno dell'altro sesso
		// c. so che ci sono pi di SOGLIA femminucce in attesa
		while( numMaschi == MAX || numFemmine > 0 || femmineInAttesa > SOGLIA) 
			wait();
		maschiInAttesa--;
		numMaschi++;
		return trovaDoccia(); // il monitor viene liberato dopo la return
	}
	int occupaDocciaFemmina()
	{
		JTCSynchronized sync(*this);
		femmineInAttesa++;
		while( numFemmine == MAX || numMaschi > 0 || maschiInAttesa > SOGLIA)
			wait();
		femmineInAttesa--;
		numFemmine++;
		return trovaDoccia(); // il monitor viene liberato dopo la return
	}
	void liberaDocciaMaschio(int doccia)
	{
		numMaschi--;
		docce[doccia] = false;
		notifyAll();
	}
    void liberaDocciaFemmina(int doccia)
	{
		numFemmine--;
		docce[doccia] = false;
		notifyAll();
	}

};
